<?php

class Execution
{
	public static
	function shot_desc($id_product, $product_shot_desc)
	{
		Db::getInstance()->Execute("
			UPDATE `"._DB_PREFIX_."product_lang`
			SET  `description_short`='".pSQL($product_shot_desc, $htmlOK = true)."'
			WHERE `id_lang`=".Configuration::get('PS_LANG_DEFAULT')." AND `id_product`= ".$id_product
		);
	}
	public static
	function desc($id_product, $product_desc)
	{
		Db::getInstance()->Execute("
			UPDATE `"._DB_PREFIX_."product_lang`
			SET  `description`='".pSQL($product_desc, $htmlOK = true)."'
			WHERE `id_lang`=".Configuration::get('PS_LANG_DEFAULT')." AND `id_product`= ".$id_product
		);
	}
	//========================================Загрузка изображений========================================
	private static
	function copyImg($id_entity, $id_image , $tmpfile)
	{
		set_time_limit(0);
		if(!file_exists(_PS_PROD_IMG_DIR_.Image::getImgFolderStatic($id_image))) mkdir(_PS_PROD_IMG_DIR_.Image::getImgFolderStatic($id_image),0777,TRUE);
		$imagesTypes = ImageType::getImagesTypes('products');
		if(empty($id_image) || (!file_exists($tmpfile))) return false;
		$pathg = _PS_PROD_IMG_DIR_ . Image::getImgFolderStatic($id_image). intval($id_image) ;
		ImageManager::resize($tmpfile, $pathg.'.jpg');
		foreach($imagesTypes AS $k )
		{
			$path = _PS_PROD_IMG_DIR_ . Image::getImgFolderStatic($id_image). intval($id_image) . '-' . $k['name'];
			ImageManager::resize($tmpfile, $path.'.jpg', $k['width'], $k['height'] );
		}
		return true;
	}
	//========================================Добавление обновление изображений========================================
	public static
	function addupdimages ($id_product,$tmpfile,$search)
	{
		// Если нет атрибута или нет картинки выходим
		if(!exif_imagetype (_PS_UPLOAD_DIR_.$tmpfile)) unlink (_PS_UPLOAD_DIR_.$tmpfile);
		if(!file_exists(_PS_UPLOAD_DIR_ . $tmpfile)) return false;
		$tmp = Db::getInstance()->ExecuteS("SELECT `tmpfile` FROM `"._DB_PREFIX_."image` WHERE `id_product`=$id_product");
		$id_shop = Configuration::get('PS_SHOP_DEFAULT');
		foreach($tmp as $image){
			$image_[] = $image['tmpfile'];
		}
		if(@in_array(basename($tmpfile, ".jpg"), $image_)){
			return FALSE;
		}
		else
		{
			$cover = Image::getCover($id_product);
			if(empty($cover)){
				$cover_shop = 1;
				$sql = "INSERT  INTO `"._DB_PREFIX_."image` (`id_product`,`cover`,`tmpfile`) VALUES ($id_product, 1, '".basename($tmpfile, ".jpg")."')";
				Db::getInstance()->Execute($sql);
			}
			else
			{
				$position   = (Image::getHighestPosition($id_product)) + 1;

				if( _PS_VERSION_ < "1.6.1"){
				$cover_shop = 0;}
				else{
				$cover_shop = 'NULL';
				}
				//$cover_shop = 0;
				$sql = "INSERT  INTO `"._DB_PREFIX_."image` (`id_product`,`cover`,`position`,`tmpfile`) VALUES ($id_product, $cover_shop, $position,'".basename($tmpfile, ".jpg")."')";
				Db::getInstance()->Execute($sql);
			}
			$id_image = Db::getInstance()->Insert_ID();
			if( _PS_VERSION_ < "1.6.1"){
				$sql = "
				INSERT IGNORE INTO `"._DB_PREFIX_."image_shop` (`id_image`,`id_shop`,`cover`)
				VALUES ($id_image, $id_shop, $cover_shop)
				";}
				else{
				$sql = "
				INSERT IGNORE INTO `"._DB_PREFIX_."image_shop` (`id_product`,`id_image`,`id_shop`,`cover`)
				VALUES ($id_product, $id_image, $id_shop, $cover_shop)
				";
				}

			Db::getInstance()->Execute($sql);

			if(self::copyImg($id_product, $id_image, _PS_UPLOAD_DIR_ .$tmpfile))
			{
				Db::getInstance()->Execute("
					INSERT IGNORE INTO `"._DB_PREFIX_."image_lang` (`id_image`,`id_lang`, `legend`)
					VALUES ($id_image, ".Configuration::get('PS_LANG_DEFAULT').", '".pSQL($search)."')
					");
			}
			else
			{
				Db::getInstance()->Execute("DELETE FROM `"._DB_PREFIX_."image` WHERE `id_image` = $id_image");
				Db::getInstance()->Execute("DELETE FROM `"._DB_PREFIX_."image_shop` WHERE `id_image` = $id_image");
			}
		}
	}

	//========================================Добавление обновление характеристик========================================
	public static
	function features($id_product, $feature, $featurevals)
	{
		$id_shop = (int)Configuration::get('PS_SHOP_DEFAULT');
		$id_lang = (int)Configuration::get('PS_LANG_DEFAULT');
		$feature = pSQL($feature);
		$id_feature = Db::getInstance()->getValue("SELECT `id_feature` FROM `"._DB_PREFIX_."feature_lang` WHERE `name`= '$feature'");
		if(empty ($id_feature))
		{
			Db::getInstance()->Execute("
				INSERT INTO `"._DB_PREFIX_."feature` VALUE ()
				");
			$id_feature = Db::getInstance()->Insert_ID();
			$sql_s = "
				INSERT IGNORE INTO `"._DB_PREFIX_."feature_shop` (`id_feature`,`id_shop`)
				VALUES ($id_feature, $id_shop)
				";
			$sql_l = "
				INSERT IGNORE INTO `"._DB_PREFIX_."feature_lang` (`id_feature`,`id_lang`, `name`)
				VALUES ($id_feature, $id_lang, '$feature')
				";
			Db::getInstance()->Execute($sql_s);
			Db::getInstance()->Execute($sql_l);
		}
		$id_feature_value = Db::getInstance()->getValue("
						SELECT fv.`id_feature_value`
						FROM `" . _DB_PREFIX_ . "feature_value` fv
						LEFT JOIN `" . _DB_PREFIX_ . "feature_value_lang` fvl
						ON fv.`id_feature_value` = fvl.`id_feature_value`
						WHERE fvl.`id_lang`=" .  $id_lang . " AND fv.`id_feature`=" . $id_feature . " AND fvl.`value`='" . $featurevals."'");
		//$id_feature_value = Db::getInstance()->getValue("SELECT `id_feature_value` FROM `"._DB_PREFIX_."feature_value_lang` WHERE `value` = '$featurevals'");
		if(empty ($id_feature_value))
		{
			FeatureValue::addFeatureValueImport($id_feature, $featurevals, $id_product);
			$id_feature_value = Db::getInstance()->getValue("SELECT `id_feature_value` FROM `"._DB_PREFIX_."feature_value_lang` WHERE `value` = '$featurevals'");
		}
		if((!empty ($id_feature)) AND (!empty ($id_feature_value)) )
		{
			Product::addFeatureProductImport($id_product, $id_feature, $id_feature_value);
		}
	}
}
