<?php
include(dirname(__FILE__) . '/../../../config/config.inc.php');
require_once(dirname(__FILE__).'/../../../images.inc.php');
require_once(dirname(__FILE__).'/Execution.php');
require_once(dirname(__FILE__).'/class.get.image.php');

if (Configuration::get('PARSER')==0){
	require_once(_PS_MODULE_DIR_.'/ecm_prestaparcer/classes/nadavi/Bparser.php');
}elseif(Configuration::get('PARSER')==1){
	require_once(_PS_MODULE_DIR_.'/ecm_prestaparcer/classes/brain/Bparser.php');
}elseif(Configuration::get('PARSER')==2){
	require_once(_PS_MODULE_DIR_.'/ecm_prestaparcer/classes/torgmail/Bparser.php');
}elseif(Configuration::get('PARSER')==3){
	require_once(_PS_MODULE_DIR_.'/ecm_prestaparcer/classes/hotline/Bparser.php');
}elseif(Configuration::get('PARSER')==4){
	require_once(_PS_MODULE_DIR_.'/ecm_prestaparcer/classes/m/Bparser.php');
}

//require_once(_PS_MODULE_DIR_.'/ecm_prestaparcer/classes/Bparser.php');
$name = Tools::getValue('name');
$value = Tools::getValue('value');
$id   = Tools::getValue('id');
$mode  = Tools::getValue('mode');
$width  = Tools::getValue('width');

$html  = "";
switch($mode){
	case "myalert":
		myalert();
		break;
	case "pause":
		usleep($value * 1000000); //200000 0.2 sec
		$html = "Pause ".$value." ms.";
		break;
	case "search_short_desc":
		$html .= Bparser::short_desc($name);
		if($html == "") $html = "Ничего не найдено";
		break;
	case "search_full_desc":
		$html .= Bparser::desc($name);
		if($html == "") $html = "Ничего не найдено";
		break;
	case "search_images":
		$num = 5;
		$i       = 0;
		$fotos   = Bparser::fotos($name);
		$imcount = count($fotos);
		if($imcount > 0)
		{
			$w = intval (650 / $imcount * $num);
			$w = intval ($width / $num);
			if($w > 150) $w = 150;
			//$html .= '<table border="0px" cellspacing="2px" cellpadding="2px" bgcolor="#cccccc">';
			$html .= '<table>';
			$html .= '<tr align=center>';
			$html .= '</tr><tr align=center >';
			foreach($fotos as $foto)
			{
				$html .= '<td><table><tr align=center >';
				$html .= '<td><div  id="impl'.$i.'"><input id="imch'.$i.'" type="checkbox" checked></div></td></tr>';
				$size = getimagesize ($foto);
				$html .= '<tr align=center ><td style="text-align:center;background-color:#FFFFFF;height:'.$w.'px;width:'.$w.'px;">';
				$html .= '<a class="fancybox" href="'.$foto.'">';
				$html .= '<img onError="ImgError(this,'.$i.')"  style="width:';
				if($size[0] < $size[1]) $html .= 'auto!important;height:90%';
				else $html .= '90%!important;height:auto';
				$html .= '!important;-ms-interpolation-mode:bicubic;margin:auto;" id="i'.$i.'" src='.$foto.' title='.$foto.' alt='.$foto.'></a></td></tr>';
				$html .= '<tr align=center ><td ><div>'.$size[0].'x'.$size[1].'</div></td></tr>';
				$html .= '<tr align=center ><td><div  id="add'.$i.'">&nbsp;</div></td></td></tr></table><td>';
				if (fmod(++$i/$num,1) == 0) $html .= "</tr><tr><td colspan='$num'><hr></td></tr><tr align=center >";
			}

			$html .= "</tr></table><a id='imcount' value=$i >&nbsp;</a>";
		}
		else
		{
			$html = "<strong>Картинок нет :(</strong>";
		}
		break;
	case "search_feature":
		$data = Bparser::features($name);
		$html .= '<table border="0px" cellspacing="2px" cellpadding="2px" bgcolor="#cccccc" width="100%">';
		$invert = '<tr><td align=right colspan="2">Инвертировать выбор&nbsp;</td><td><input title="Обратить выбор" onclick="inverse()" id="chup" type="button" value="R"></td></tr>';
		$html .= $invert;
		$i = 0;
		foreach($data as $features)
		{
			if($i % 2 == 0) $bgcolor = "#FFFFFF";
			else $bgcolor      = "#EFEFEF";
			$featurevalue = strip_tags($features['value']);
			$html .= '<tr bgcolor="'.$bgcolor.'"><td id="f'.$i.'" value="'.$features["feature"].'"><b>'.$features["feature"].'</b> </td>';
			$html .= '<td id="v'.$i.'" value="'.$featurevalue.'">'.$featurevalue.'</td>';
			$html .= '<td><input id="ch'.$i++.'" type="checkbox" unchecked></td></tr>';
		}
		//$text = translate('Invert selection');
		//p ($text);
		$html .= $invert;
		$html .= '</table>';
		$html .= '<a id="fcount" value='.--$i.'></a>';
		if($i == 0) $html = "<strong>Свойств нет :(</strong>";
		break;
	case "short_desc":
		Execution::shot_desc($id, $value);
		$html  .= Db::getInstance()->getValue("SELECT description_short FROM "._DB_PREFIX_.
			"product_lang WHERE id_lang =".Configuration::get('PS_LANG_DEFAULT')." AND id_product = ".$id);
		break;
	case "full_desc":
		Execution::desc($id, $value);
		$html .= Db::getInstance()->getValue("SELECT description FROM "._DB_PREFIX_.
		"product_lang WHERE id_lang =".Configuration::get('PS_LANG_DEFAULT')." AND id_product = ".$id );
		break;
	case "images":
		$foto   = Tools::getValue('foto');
		$search = Tools::getValue('search');
		import_image($foto, $id, $search);
		$html   = "<strong>Добавлено!</strong>";
		break;
	case "feature":
		$feature       = Tools::getValue('feature');
		$feature_value = Tools::getValue('feature_value');
		$html          = Execution::features($id, $feature, $feature_value);
		$html          = "Добавлено";
		break;
	default: break;
}
exit ($html);

function get_image($image_url){
	$image = new GetImage;
	//$image_url1 = trim(str_replace('"',' ',$image_url));
	$image->source = $image_url;
	$image->save_to = _PS_UPLOAD_DIR_;
	$get = $image->download('curl');
}

function import_image($foto,$id_product,$search){
	get_image($foto);
	$image_tmp = basename($foto);
	Execution::addupdimages($id_product,$image_tmp,$search);
}

function myalert(){
	global $smarty, $cookie;
	$id_lang = $cookie->id_lang;
	$smarty->assign(
		array(
			'id_lang' => $id_lang,
		)
	);
	$smarty->display('../views/myalert.tpl');
}

?>
